
/* Generated by Interface Builder */

#import "CompView.h"
#import <appkit/appkit.h>

@implementation CompView

#define COPY 0
#define SOVER 1

- initFrame:(const NXRect *)theFrame
{
    [super initFrame:theFrame];
    currentPoint.x=oldPoint.x=bounds.size.width/2.0;
    currentPoint.y=oldPoint.y=bounds.size.height/2.0;
    compType=NX_COPY;
    [self setSqImage];			//create image of square
    bgImage=[[NXImage alloc] initSize:&bounds.size];
    backgroundGray=NX_WHITE;
    [self setBgImage];			//create background image
    return self;
}

- (float)backgroundGray
{
    return backgroundGray;
}

- newBackgroundGray:sender
{
    backgroundGray = [sender floatValue];
    [self setBgImage];			//reset background image with new gray
    [self display];
    return self;
}

- compositeType:sender
{
    int comp;
    comp=[[sender selectedCell] tag];
    if (comp == COPY) compType=NX_COPY;
    if (comp == SOVER) compType=NX_SOVER;
    return self;
}

- xPosition:sender
{
    oldRect.origin=currentPoint;	//save origin of where the square WAS
    currentPoint.x=[sender floatValue]*bounds.size.width;   //set new location
    [self moveSquare];			//now move square from old to new
    return self;
}

- setSqImage
{   // This creates the square image that is moved around
    sqSide=100.;
    NXSetRect(&sqRect,0.0,0.0,sqSide,sqSide);
    sqImage=[[NXImage alloc] initSize:&sqRect.size];
    [sqImage lockFocus];
         [sqImage composite:NX_CLEAR fromRect:&sqRect toPoint:&sqRect.origin];
         PSsetgray(NX_BLACK);
         NXFrameRectWithWidth(&sqRect,5.0);
	 [self simulateDrawingTime];	// simulate a long time to draw the movable image
    [sqImage unlockFocus];
/* Now set up square to move FROM in background */
    oldRect.size=sqRect.size;		//The old square is always this size
    oldRect.origin.x=currentPoint.x;	//These are used only at initialization 
    oldRect.origin.y=currentPoint.y;
    return self;
}

- setBgImage
{   //This creates the background image
    [bgImage lockFocus];
        PSsetgray(backgroundGray);
        NXRectFill(&bounds);
        [self simulateDrawingTime];	// simulate a long time to draw the background
    [bgImage unlockFocus];
    return self;
}

- drawSelf:(const NXRect *)r :(int)c
{   //Here we just display the entire background, then the square
    [bgImage composite:NX_COPY toPoint:&bounds.origin];
    [sqImage composite:compType toPoint:&currentPoint];
    return self;
}

- moveSquare
{
   [self lockFocus];
        /* First, erase square by copying background square on top of it */
        [bgImage composite:NX_COPY fromRect:&oldRect toPoint:&oldRect.origin];
        /* Now composite square to new location */
        [sqImage composite:compType toPoint:&currentPoint];
    [self unlockFocus];
    return self;
}
    
- mouseDownAction:(NXPoint *)currentLocation
{	
    NXBeep();			//just for fun
    [self mouseDraggedAction:currentLocation];  //now do same as when dragging
    return self;
}

- mouseDraggedAction:(NXPoint *)currentLocation
{   // Move square to follow the mouse
    oldRect.origin=currentPoint;
    currentPoint=*currentLocation;
    [self moveSquare];
    [xSlider setFloatValue:currentLocation->x/bounds.size.width];  //update slider
    return self;
}

- mouseUpAction:(NXPoint *)currentLocation
{
    NXBeep();		//just for fun again
    return self;
}

- simulateDrawingTime
{  //This method wastes time to simulate complex PostScript drawing
	int i=0;
	int time=[timeSlider intValue];
	for (i=0; i<= time; i++);
	return self;
}


@end
