#import <appkit/appkit.h>
#import "AShape.h"
#define DEFAULTFILL NO
#define DEFAULTSHADE 0.0
#define NOBBYSIZE 6.0

id nobby=nil;

massageRect(r)
NXRect *r;
{
    if(r->size.width<0){
    	r->size.width = fabs(r->size.width);
	r->origin.x -= r->size.width;
    }
    if(r->size.height<0){
    	r->size.height = fabs(r->size.height);
	r->origin.y -= r->size.height;
    }
}

@implementation AShape

+newShapeWithBBox:(NXRect *)r;
{
    self = [super new];
    bbox = *r;
    fill = DEFAULTFILL;
    shade = DEFAULTSHADE;
    selectFlag = NO;
    if(nobby==nil)
	[self makeNobby];
    return self;
}

-(BOOL)needsView{ return NO;}

-makeNobby
{
    NXRect r = {0.0,0.0,NOBBYSIZE,NOBBYSIZE};
    nobby = [Bitmap newSize:NOBBYSIZE :NOBBYSIZE type:NX_UNIQUEBITMAP];
    [nobby lockFocus];
	PSsetgray(.333);
	NXRectFill(&r);
    [nobby unlockFocus];
    return self;
}

-setFill:(int)i
{
   if(fill !=i){
       fill = i;
   }
   return self;
}
 
-(int)fill {return fill;}

-setShade:(float)s
{
   if(shade !=s){
       shade = s;
   }
   return self;
}

-(float)shade{return shade;}

-setBbox:(NXRect *)r
{
    bbox = *r;
    massageRect(&bbox);
    return self;
}

-(NXRect *)bbox {return &bbox;}

-setSelection:(BOOL)sf;
{
    if(selectFlag = sf)
	[self drawNobbies];
}

-(int)containsPt:(NXPoint *)p;
{
    return(NXMouseInRect(p,&bbox,NO));
}

-edit
{
    selectFlag = YES;
    return self;
}

-endEdit
{
    selectFlag = NO;
    return self;
}

-drawNobbies
{
    NXPoint p;
    
    p = bbox.origin;
    p.x -= NOBBYSIZE/2.;
    p.y -= NOBBYSIZE/2.;
    [nobby composite:NX_SOVER toPoint:&p];
    p.y += bbox.size.height;
    [nobby composite:NX_SOVER toPoint:&p];
    p.x += bbox.size.width;
    [nobby composite:NX_SOVER toPoint:&p];
    p.y -= bbox.size.height;
    [nobby composite:NX_SOVER toPoint:&p];
    return self;
}

-drawPrep
{
    return self;
}

-drawShape
{
    PSsetgray(shade);
    if(fill)
	NXRectFill(&bbox);
    else
	NXFrameRect(&bbox);
    if(selectFlag)
	[self drawNobbies];
}

-drawObject
{
    [self drawShape];
    if(selectFlag)
	[self drawNobbies];
    return self;
}

-write:(NXTypedStream *)s
{
    [super write:s];
    NXWriteRect(s,&bbox);
    NXWriteTypes(s,"ifi",&fill,&shade,&selectFlag);
    return self;
}

-read:(NXTypedStream *)s
{
    [super read:s];
    NXReadRect(s,&bbox);
    NXReadTypes(s,"ifi",&fill,&shade,&selectFlag);
    return self;
}	
