#import <appkit/appkit.h>
#import "ScrollingDrawView.h"
#import "DrawView.h"

@implementation ScrollingDrawView:ScrollView

+newFrame:(NXRect const *)r
{
    NXRect	dr={0.,0.,0.,0.};
    self = [super newFrame:r];
    [self setVertScrollerRequired:YES];
    [self getPageRect:&dr];
    docView = [DrawView newFrame:&dr inSV:self];
    [self setDocView:docView];
    [docView setSimpleDraw:NO];
    [contentView setAutoresizeSubviews:YES];
    [contentView setAutosizing:NX_HEIGHTSIZABLE|NX_WIDTHSIZABLE];
    [NXApp setDelegate:self];    
    return self;
}

-appDidInit:sender
{
    [window setDelegate:docView];
    return self;
}

-getPageRect:(NXRect *)r
{
    float	lm,rm,tm,bm;
    id	pInfo;    
    pInfo = [NXApp printInfo];
    *r = *[pInfo paperRect];
    [[NXApp printInfo] getMarginLeft:&lm right:&rm top:&tm bottom:&bm];
    r->size.height -= tm+bm;
    r->size.width  -= lm+rm;
    return self;
}

-setShadeFromSender:sender
{
    [docView setCurrentShade:[sender floatValue]];
    return self;
}
 
-setFillFromSender:sender
{
    [docView setFill:[sender selectedTag]];
    return self;
}

-setDrawType:sender
{
    [docView setDrawType:sender];
    return self;
}

-erase:sender
{
    [docView erase:sender];
    return self;
}

-clear:sender
{
    [docView clear:sender];
    return self;
}

-print:sender
{
    [docView printPSCode:sender];
}

-reDraw:sender
{
    [docView reDraw:sender];
}

@end 
