#import <appkit/appkit.h>
#import "TextShape.h"
#define TSINSET 2.0

char buf[512];

@implementation TextShape

+newShapeWithBBox:(NXRect *)bb
{
    self = [super newShapeWithBBox:bb];
    cell = [TextFieldCell newTextCell:"Empty Cell"];
    cacheFlag = YES;
    [cell setBordered:NO];
    [cell setEditable:YES];
    return self;
}

-(BOOL)needsView {return YES;}

-setView:anObject;
{
    view = anObject;
    return self;
}

-setBbox:(NXRect *)r
{
    [super setBbox:r];
    tbbox = bbox;
    NXInsetRect(&tbbox,TSINSET,TSINSET);
    return self;
}

-setShade:(float)f
{
    [super setShade:f];
    [cell setTextGray:shade];
    return self;
}

-edit:(int)start length:(int)l
{
    fe = [[view window] getFieldEditor:YES for:self];
    [view lockFocus];
    [cell select:&bbox inView:view editor:fe delegate:self
	start:start length:l];
    [view unlockFocus];
    return self;
}
-edit
{
    [super edit];
    [self edit:0 length:512];
    return self;
}

-endEdit
{
    [super endEdit];
    [self drawPrep];
    [cell endEditing:fe];
    fe = nil;
    return self;
}

-setSelection:(BOOL)isSelected
{
    [super setSelection:isSelected];
    if(!selectFlag)
	[self endEdit];
    return self;
}
    
-textDidEnd:t endChar:(char)c;
{
    [self endEdit];
    return self;
}

-textDidChange:t 
{
    if(!cacheFlag)
	cacheFlag = YES;
    return self;
}

-changeFont:sender
{
    NXRect r;
    NXSelPt bp,ep;
    int flag=NO;
    
    [cell setFont:[sender convertFont:[cell font]]];
    r = bbox;
    if(fe){
	flag = YES;
	[fe getSel:&bp :&ep];
	[self endEdit];
    }
    [cell calcCellSize:&r.size inRect:&bbox];
    [self setBbox:&r];
    if(flag){
    	selectFlag = YES;
	[self drawObject];
	[self edit:bp.cp length:(ep.cp-bp.cp)];
    }
    else [self drawObject];
    return self;
} 
    
-drawPrep;
{
    if(cacheFlag&&(fe !=nil)){
	[fe getSubstring:buf start:0 length:512];
	[cell setStringValue:buf];
    	cacheFlag = NO;
    }
    return self;
}

-drawNobbies
{
    PSsetgray(.666);
    NXFrameRect(&bbox);
    [super drawNobbies];
    return self;
}

-drawShape;
{
    [cell drawSelf:&bbox inView:view];
    return self;
}

-read:(NXTypedStream *)s
{
    [super read:s];
    cell = NXReadObject(s);
    NXReadType(s,"i",&cacheFlag);
    NXReadRect(s,&tbbox);
    return self;
}

-write:(NXTypedStream *)s
{
    [super write:s];
    NXWriteObject(s,cell);
    NXWriteType(s,"i",&cacheFlag);
    NXWriteRect(s,&tbbox);
    return self;
}
 
