/*Objective_C Implementation of the SquareMatrix Class: SquareMatrix.m*/

#import <stdio.h>
#import "SquareMatrix.h"
#import <objc/List.h>
#import <objc/Storage.h>

@implementation SquareMatrix

- init {
	return [self initRows:1];
	}
	
- initRows:(int)rows  {
	int i;
	if(columnList) {			//if previously initialized, free up
		[columnList freeObjects];
		[columnList free];
		}
	numberOfRows = numberOfColumns = rows;
	columnList = [[List alloc] initCount:numberOfColumns];
	for(i=0;i<numberOfColumns;i++) 
	[columnList addObject:[[Storage  alloc] initCount :numberOfRows
		elementSize:sizeof(float)
 		description:"f"]];
	return self;
}
				   
//Return element at (row,column)
-(float)elementAtRow:(int)row Column:(int)column{

	if(! [self checkRow:row Column:column]) return 0.0;

	return *(float *)[[columnList  objectAt:column] elementAt:row];
}

//Set element at (row,column)
-setElementAtRow:(int)row Column:(int)column To:(float)aNumber {

	if( [self checkRow:row Column:column]) 
		[[columnList  objectAt:column] replace:&aNumber at:row];
	return self;
}
  

//Transpose the matrix
-transpose{
float upper,lower;
int i, j, fromIndex=0;

	for(i=0;i<numberOfRows;i++) {
	  for(j=fromIndex;j<numberOfColumns;j++) {
	    lower = [self elementAtRow:i Column:j];
	    upper = [self elementAtRow:j Column:i];
	    [self setElementAtRow:j Column:i To:lower];
	    [self setElementAtRow:i Column:j To:upper];
	  }
	  fromIndex++;
	}
	return self;
}

- (BOOL) checkRow:(int)row Column:(int)column {
	if ((row >= numberOfRows)||(column >= numberOfColumns))
		return NO;
	else
		return YES;
}

//Free the matrix
- free{
	[columnList freeObjects];
	[columnList free];
	return [super free];
}

//Print the elements in the matrix
-printMatrix{
	int i, j;	
	printf("Contents of the Matrix:\n");
	for(j=0;j<numberOfColumns;j++)
	  for(i=0;i<numberOfRows;i++)
	    printf("Element at Location [%i %i] is %f\n", i, j, [self elementAtRow:i Column:j]);
	return self;
}
@end
