/* Objective_C Implementation of the Fruit Class: Fruit.m */

#import "Fruit.h"
#import  <appkit/graphics.h>
#import <dpsclient/wraps.h>
#import  <appkit/TextField.h>
#import  <string.h>
#import  <stdio.h>

@implementation Fruit : View

#define RED 0.0		//black
#define GREEN 0.4		//a dark gray
#define YELLOW 0.7	//a very light gray

//Intialize display to be showing correct current values
-appDidInit:sender{
	[self display:self];	//This is display:, not display  !
	return self;
}

// Initialize a new fruit
-initFrame:(NXRect *)frameRect {
	[super initFrame:frameRect];	//super's initialization
	diameter=1;		// init the diameter
	color="red" ; 	// init the color
	colorVariable = RED;
	return self;			// return the new instance
}
//set color from a radio button matrix
-setColor:sender  {
	switch( [sender   selectedTag]){
	case 0:	colorVariable = RED;
			color = "red";
				break;
	case 1:	colorVariable =GREEN;
	 		color = "green";
				break;
	case 2:	colorVariable = YELLOW;
			color = "yellow";
				break;
	default:	break;
	}
	[self display];
	return self;
}

//set color
-color:( const char *)aColor{
	color=aColor;
	return self;
}

//Return the value of the color instance variable
- (const char *) color {
	return color;
}

//set diameter from a control
-setDiameter:sender  {
	diameter = [sender    intValue];
	[self  display];
	return self;
}

//Set the diameter
-diameter: (int )dia {
	diameter = dia;
	return self;
}

//Return the value of diameter
- (int) diameter {
	return diameter;
}

// Tell a Fruit object to increase its diameter
- grow:sender  {
	[self diameter: ([self diameter] + 1)];  //better than:  diameter=diameter+1
	[self  display];
	return self;
}

- display:sender  {
	[colorDisplay	setStringValue:[self    color]];   	[diameterDisplay    setIntValue:[self  diameter] ]; 
	return self;
}
- drawSelf:(NXRect*)r :(int)c
{
     float side;
     /* Let's fill with gray rather than erase to white */
     PSsetgray(NX_LTGRAY);
     NXRectFill(&bounds);		//"erase" to gray
    PSsetgray(colorVariable);	//for drawing, set to selected "color"
    side = [self	diameter];
     
     PSnewpath();
     PSmoveto(bounds.size.width/2.0-side/2.0, bounds.size.height/2.0-side/2.0);
     PSrlineto(0.0, side);
      PSrlineto(side,0.0);
      PSrlineto(0.0,-side);
      PSclosepath();

     PSfill();		//fill the defined path
     return self;
}

@end
